diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/hud.py ns-3.41/src/visualizer/visualizer/hud.py
--- ns-3.40/src/visualizer/visualizer/hud.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/hud.py	2024-02-09 14:44:08.561794800 -0800
@@ -1,8 +1,8 @@
 import math
+
+from gi.repository import GooCanvas, Gtk, Pango
+
 from .base import PIXELS_PER_METER
-from gi.repository import Pango
-from gi.repository import Gtk
-from gi.repository import GooCanvas
 
 
 ## Axes class
@@ -28,16 +28,22 @@
         """
         self.viz = viz
         self.color = 0x8080C0FF
-        self.hlines = GooCanvas.CanvasPath(parent=viz.canvas.get_root_item(), stroke_color_rgba=self.color)
+        self.hlines = GooCanvas.CanvasPath(
+            parent=viz.canvas.get_root_item(), stroke_color_rgba=self.color
+        )
         self.hlines.lower(None)
-        self.vlines = GooCanvas.CanvasPath(parent=viz.canvas.get_root_item(), stroke_color_rgba=self.color)
+        self.vlines = GooCanvas.CanvasPath(
+            parent=viz.canvas.get_root_item(), stroke_color_rgba=self.color
+        )
         self.vlines.lower(None)
         self.labels = []
         hadj = self.viz.get_hadjustment()
         vadj = self.viz.get_vadjustment()
+
         def update(adj):
             if self.visible:
                 self.update_view()
+
         hadj.connect("value-changed", update)
         vadj.connect("value-changed", update)
         hadj.connect("changed", update)
@@ -76,7 +82,7 @@
         dx = xf - xi
         size = dx
         ndiv = 5
-        text_width = dx/ndiv/2
+        text_width = dx / ndiv / 2
 
         def rint(x):
             """!
@@ -85,23 +91,25 @@
             @param x: x
             @return x rounded up
             """
-            return math.floor(x+0.5)
+            return math.floor(x + 0.5)
 
         dx_over_ndiv = dx / ndiv
-        for n in range(5): # iterate 5 times to find optimum division size
-            #/* div: length of each division */
-            tbe = math.log10(dx_over_ndiv)#;   /* looking for approx. 'ndiv' divisions in a length 'dx' */
-            div = pow(10, rint(tbe))#;         /* div: power of 10 closest to dx/ndiv */
-            if math.fabs(div/2 - dx_over_ndiv) < math.fabs(div - dx_over_ndiv): #/* test if div/2 is closer to dx/ndiv */
+        for n in range(5):  # iterate 5 times to find optimum division size
+            # div: length of each division
+            # looking for approx. 'ndiv' divisions in a length 'dx'
+            tbe = math.log10(dx_over_ndiv)
+            # div: power of 10 closest to dx/ndiv
+            div = pow(10, rint(tbe))
+            # test if div/2 is closer to dx/ndiv
+            if math.fabs(div / 2 - dx_over_ndiv) < math.fabs(div - dx_over_ndiv):
                 div /= 2
-            elif math.fabs(div*2 - dx_over_ndiv) < math.fabs(div - dx_over_ndiv):
-                div *= 2 # /* test if div*2 is closer to dx/ndiv */
-            x0 = div*math.ceil(xi / div) - div
+            elif math.fabs(div * 2 - dx_over_ndiv) < math.fabs(div - dx_over_ndiv):
+                div *= 2  # test if div*2 is closer to dx/ndiv
+            x0 = div * math.ceil(xi / div) - div
             if n > 1:
                 ndiv = rint(size / text_width)
         return x0, div
 
-
     def update_view(self):
         """!
         Update view function
@@ -116,6 +124,7 @@
         self.labels = []
         for label in unused_labels:
             label.set_property("visibility", GooCanvas.CanvasItemVisibility.HIDDEN)
+
         def get_label():
             """!
             Get label function
@@ -126,7 +135,9 @@
             try:
                 label = unused_labels.pop(0)
             except IndexError:
-                label = GooCanvas.CanvasText(parent=self.viz.canvas.get_root_item(), stroke_color_rgba=self.color)
+                label = GooCanvas.CanvasText(
+                    parent=self.viz.canvas.get_root_item(), stroke_color_rgba=self.color
+                )
             else:
                 label.set_property("visibility", GooCanvas.CanvasItemVisibility.VISIBLE)
                 label.lower(None)
@@ -136,31 +147,37 @@
         hadj = self.viz.get_hadjustment()
         vadj = self.viz.get_vadjustment()
         zoom = self.viz.zoom.get_value()
-        offset = 10/zoom
+        offset = 10 / zoom
 
         x1, y1 = self.viz.canvas.convert_from_pixels(hadj.get_value(), vadj.get_value())
-        x2, y2 = self.viz.canvas.convert_from_pixels(hadj.get_value() + hadj.get_page_size(), vadj.get_value() + vadj.get_page_size())
-        line_width = 5.0/self.viz.zoom.get_value()
+        x2, y2 = self.viz.canvas.convert_from_pixels(
+            hadj.get_value() + hadj.get_page_size(), vadj.get_value() + vadj.get_page_size()
+        )
+        line_width = 5.0 / self.viz.zoom.get_value()
 
         # draw the horizontal axis
         self.hlines.set_property("line-width", line_width)
-        yc = y2 - line_width/2
+        yc = y2 - line_width / 2
 
-        sim_x1 = x1/PIXELS_PER_METER
-        sim_x2 = x2/PIXELS_PER_METER
+        sim_x1 = x1 / PIXELS_PER_METER
+        sim_x2 = x2 / PIXELS_PER_METER
         x0, xdiv = self._compute_divisions(sim_x1, sim_x2)
         path = ["M %r %r L %r %r" % (x1, yc, x2, yc)]
         x = x0
         while x < sim_x2:
-            path.append("M %r %r L %r %r" % (PIXELS_PER_METER*x, yc - offset, PIXELS_PER_METER*x, yc))
+            path.append(
+                "M %r %r L %r %r" % (PIXELS_PER_METER * x, yc - offset, PIXELS_PER_METER * x, yc)
+            )
             label = get_label()
-            label.set_properties(font=("Sans Serif %f" % int(12/zoom)),
-                                 text=("%G" % x),
-                                 fill_color_rgba=self.color,
-                                 alignment=Pango.Alignment.CENTER,
-                                 # anchor=Gtk.Widget.ANCHOR_S,
-                                 x=PIXELS_PER_METER*x,
-                                 y=(yc - offset))
+            label.set_properties(
+                font=("Sans Serif %f" % int(12 / zoom)),
+                text=("%G" % x),
+                fill_color_rgba=self.color,
+                alignment=Pango.Alignment.CENTER,
+                # anchor=Gtk.Widget.ANCHOR_S,
+                x=PIXELS_PER_METER * x,
+                y=(yc - offset),
+            )
             x += xdiv
         del x
 
@@ -168,29 +185,30 @@
 
         # draw the vertical axis
         self.vlines.set_property("line-width", line_width)
-        xc = x1 + line_width/2
-
-        sim_y1 = y1/PIXELS_PER_METER
-        sim_y2 = y2/PIXELS_PER_METER
+        xc = x1 + line_width / 2
 
+        sim_y1 = y1 / PIXELS_PER_METER
+        sim_y2 = y2 / PIXELS_PER_METER
 
         y0, ydiv = self._compute_divisions(sim_y1, sim_y2)
         path = ["M %r %r L %r %r" % (xc, y1, xc, y2)]
         y = y0
         while y < sim_y2:
-            path.append("M %r %r L %r %r" % (xc, PIXELS_PER_METER*y, xc + offset, PIXELS_PER_METER*y))
+            path.append(
+                "M %r %r L %r %r" % (xc, PIXELS_PER_METER * y, xc + offset, PIXELS_PER_METER * y)
+            )
             label = get_label()
-            label.set_properties(font=("Sans Serif %f" % int(12/zoom)),
-                                 text=("%G" % y),
-                                 fill_color_rgba=self.color,
-                                 alignment=Pango.Alignment.LEFT,
-                                 # anchor=Gtk.ANCHOR_W,
-                                 x=xc + offset,
-                                 y=PIXELS_PER_METER*y)
+            label.set_properties(
+                font=("Sans Serif %f" % int(12 / zoom)),
+                text=("%G" % y),
+                fill_color_rgba=self.color,
+                alignment=Pango.Alignment.LEFT,
+                # anchor=Gtk.ANCHOR_W,
+                x=xc + offset,
+                y=PIXELS_PER_METER * y,
+            )
             y += ydiv
 
         self.vlines.set_property("data", " ".join(path))
 
-
-
         self.labels.extend(unused_labels)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/__init__.py ns-3.41/src/visualizer/visualizer/__init__.py
--- ns-3.40/src/visualizer/visualizer/__init__.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/__init__.py	2024-02-09 14:44:08.561794800 -0800
@@ -2,14 +2,27 @@
 
 # Some useful tricks for visualizer
 # we need to check if the node has a mobility model, but we can't pass Ptr<MobilityModel> to python
-ns.cppyy.cppdef("""using namespace ns3; bool hasMobilityModel(Ptr<Node> node){ return !(node->GetObject<MobilityModel>() == 0); };""")
-ns.cppyy.cppdef("""using namespace ns3; Vector3D getNodePosition(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetPosition(); };""")
-ns.cppyy.cppdef("""using namespace ns3; Ptr<Ipv4> getNodeIpv4(Ptr<Node> node){ return node->GetObject<Ipv4>(); };""")
-ns.cppyy.cppdef("""using namespace ns3; Ptr<Ipv6> getNodeIpv6(Ptr<Node> node){ return node->GetObject<Ipv6>(); };""")
-ns.cppyy.cppdef("""using namespace ns3; std::string getMobilityModelName(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetInstanceTypeId().GetName(); };""")
-ns.cppyy.cppdef("""using namespace ns3; bool hasOlsr(Ptr<Node> node){ return !(node->GetObject<olsr::RoutingProtocol>() == 0); };""")
-ns.cppyy.cppdef("""using namespace ns3; Ptr<olsr::RoutingProtocol> getNodeOlsr(Ptr<Node> node){ return node->GetObject<olsr::RoutingProtocol>(); };""")
+ns.cppyy.cppdef(
+    """using namespace ns3; bool hasMobilityModel(Ptr<Node> node){ return !(node->GetObject<MobilityModel>() == 0); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; Vector3D getNodePosition(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetPosition(); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; Ptr<Ipv4> getNodeIpv4(Ptr<Node> node){ return node->GetObject<Ipv4>(); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; Ptr<Ipv6> getNodeIpv6(Ptr<Node> node){ return node->GetObject<Ipv6>(); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; std::string getMobilityModelName(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetInstanceTypeId().GetName(); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; bool hasOlsr(Ptr<Node> node){ return !(node->GetObject<olsr::RoutingProtocol>() == 0); };"""
+)
+ns.cppyy.cppdef(
+    """using namespace ns3; Ptr<olsr::RoutingProtocol> getNodeOlsr(Ptr<Node> node){ return node->GetObject<olsr::RoutingProtocol>(); };"""
+)
 
 
-from .core import start, register_plugin, set_bounds, add_initialization_hook
-
+from .core import add_initialization_hook, register_plugin, set_bounds, start
